﻿using System;
using JetBrains.Annotations;
using OpcLabs.BaseLib.ComponentModel.Internal;
using OpcLabs.BaseLib.ComponentModel.Referencing;

namespace OpcLabs.BaseLibFactory.ComponentModel
{
    static public class EventSourceInstances
    {
        [Serializable]
        private class TestExtenderEventProvider : IExtenderEventProvider
        {
            // ReSharper disable once UnusedParameter.Local
            // ReSharper disable once MemberCanBeMadeStatic.Local
            private bool Equals(TestExtenderEventProvider other)
            {
                return true;
            }

            public override bool Equals(object obj)
            {
                if (ReferenceEquals(null, obj)) return false;
                if (ReferenceEquals(this, obj)) return true;
                // ReSharper disable once ConvertIfStatementToReturnStatement
                if (obj.GetType() != /*this.*/GetType()) return false;
                return Equals((TestExtenderEventProvider) obj);
            }

            /// <inheritdoc cref="object.GetHashCode()"/>
            public override int GetHashCode()
            {
                return 0;
            }

            public bool CanExtend(object extendee)
            {
                throw new NotImplementedException();
            }
        }

        [NotNull]
        static public EventSource Instance0 => new EventSource();

        [NotNull]
        static public EventSource Instance1 => new EventSource(null, "testsourcePath1", null);

        [NotNull]
        static public EventSource Instance2 => new EventSource(new TestComponent(), "", null);

        [NotNull]
        static public EventSource Instance3 => new EventSource(null, "", new TestExtenderEventProvider());

        [NotNull]
        static public EventSource Instance4 => new EventSource(new TestComponent(), "testsourcePath1", new TestExtenderEventProvider());

        [NotNull]
        static public EventSource Instance5 => new EventSource(new TestComponent(), "element1.element2.element3", new TestExtenderEventProvider());
    }
}
