﻿using JetBrains.Annotations;
using OpcLabs.BaseLibFactory;
using OpcLabs.EasyOpc.DataAccess;

namespace OpcLabs.EasyOpcFactory.DataAccess
{
    static public class DAVtqInstances
    {
        // same as Null
        //[NotNull]
        //static public DAVtq Instance0 => new DAVtq();

        [NotNull]
        static public DAVtq ADouble => new DAVtq(3.141d, DateTimeUtcInstances.Kind_Utc, DAQualityInstances.GoodNonspecific);

        [NotNull]
        static public DAVtq AString => new DAVtq("testString", DateTimeUtcInstances.Kind_Utc, DAQualityInstances.GoodNonspecific);

        // no - local times are not allowed
        //[NotNull]
        //static public DAVtq Local => new DAVtq(111, DateTimeLocalInstances.Kind_Local, DAQualityInstances.GoodNonspecific);

            // no - unspecified times are not allowed
        //[NotNull]
        //static public DAVtq Unspecified => new DAVtq(111, DateTimeUnspecifiedNormalInstances.Kind_Unspecified, DAQualityInstances.GoodNonspecific);

        [NotNull]
        static public DAVtq MinTimestamp => new DAVtq(111, DateTimeUnspecifiedInstances.MinValue, DAQualityInstances.GoodNonspecific);

        [NotNull]
        static public DAVtq MaxTimestamp => new DAVtq(111, DateTimeUnspecifiedInstances.MaxValue, DAQualityInstances.GoodNonspecific);

        [NotNull]
        static public DAVtq Uncertain => new DAVtq(111, DateTimeUtcInstances.Kind_Utc, DAQualities.UncertainNonspecific);

        [NotNull]
        static public DAVtq Bad => new DAVtq(111, DateTimeUtcInstances.Kind_Utc, DAQualities.BadNonspecific);
    }
}
