﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.Implementation.NetApi.DataAccess;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    //[TestClass]
    // ReSharper disable once InconsistentNaming
    public class EasyDAClientTest_NetApi
    {
        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientCatalogTest_NetApi_IEasyDAClient_Functional : IEasyDAClientCatalogTest_Functional
        {
            public EasyDAClientCatalogTest_NetApi_IEasyDAClient_Functional()
                : base(
                    () => new EasyDAClient { InstanceParameters = {EnableNativeClient = false, EnableNetApiClient = true, EnableServiceClient = false}}, 
                    new DAServerCatalog(DAServerCatalogEntries.Real))
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_NetApi_IEasyDAClient_Com : IEasyDAClientTest_Com
        {
            public EasyDAClientTest_NetApi_IEasyDAClient_Com()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = false, EnableNetApiClient = true, EnableServiceClient = false } })
            {
            }

            [TestCategory("Live")]
            [TestCategory("OpcClassic")]
            [TestCategory("OpcDataAccess")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void Direct_SubscribeItemTest_Repeated_3_Immediate()
            {
                SubscribeItemTest_Repeated(
                    new NetApiEasyDAClient(),   // intentionally not the EasyDAClient here
                    new ServerDescriptor("", OpcLabs_KitServer.ProgId),
                    new DAItemDescriptor(OpcLabs_KitServer.ItemIds.Incrementing_1s),
                    unsubscribeAllItems: false,
                    iterationCount: 3,
                    delayBetweenIterations: 0);
            }

            [TestCategory("Live")]
            [TestCategory("OpcClassic")]
            [TestCategory("OpcDataAccess")]
            [TestCategory("TimeDomain")]
            [TestMethod]
            public void Direct_SubscribeItemTest_Repeated_3_Delayed()
            {
                SubscribeItemTest_Repeated(
                    new NetApiEasyDAClient(),   // intentionally not the EasyDAClient here
                    new ServerDescriptor("", OpcLabs_KitServer.ProgId),
                    new DAItemDescriptor(OpcLabs_KitServer.ItemIds.Incrementing_1s),
                    unsubscribeAllItems: false,
                    iterationCount: 3,
                    // ReSharper disable RedundantArgumentName
                    delayBetweenIterations: 2 * 1000);
                // ReSharper restore RedundantArgumentName
            }

        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class EasyDAClientTest_NetApi_IEasyDAClient_Intrinsic : IEasyDAClientTest_Intrinsic
        {
            public EasyDAClientTest_NetApi_IEasyDAClient_Intrinsic()
                : base(() => new EasyDAClient { InstanceParameters = { EnableNativeClient = false, EnableNetApiClient = true, EnableServiceClient = false } })
            {
            }
        }

    }
}
