﻿using System.Linq;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.DataAccess.OperationModel;
using OpcLabs.EasyOpcFactory.DataAccess.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess.OperationModel
{
    public partial class DAItemGroupArgumentsTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTestArray()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetArray(), SerializationAssertionArray);
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestArray()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetArray(), SerializationAssertionArray);
        }

        [NotNull]
        private DAItemGroupArguments CreateSerializationTarget2()
        {
            return new DAItemGroupArguments("machine1", "company1.class1",
                "branch1.item2", VarTypes.R8, 987, 8.7654f, state: 888888882);
        }

        [NotNull]
        private DAItemGroupArguments[] CreateSerializationTargetArray()
        {
            return new[] { DAItemGroupArgumentsInstances.Instance0, DAItemGroupArgumentsInstances.Instance1, CreateSerializationTarget2() };
        }

        public void SerializationAssertionArray(DAItemGroupArguments[] target, DAItemGroupArguments[] actual)
        {
            Check.Assert(target != null);

            Assert.IsNotNull(actual);
            Assert.IsTrue(target.SequenceEqual(actual));
        }
    }
}
