﻿using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.PubSub;
using OpcLabs.EasyOpc.UA.PubSub.Extensions;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.PubSub
{
    public partial class EasyUASubscriberTest
    {
        // ReSharper disable once InconsistentNaming
        private const string Open62541_TutorialPubSubPublishFileName = @"UA\PubSub\open62541-tutorial_pubsub_publish.pcap";
        
        [TestMethod]
        public void PcapTest()
        {
            TestSection.Arrange();

            Assembly executingAssembly = Assembly.GetExecutingAssembly();
            // ReSharper disable once AssignNullToNotNullAttribute
            string captureFileName = Path.Combine(Path.GetDirectoryName(executingAssembly.Location), Open62541_TutorialPubSubPublishFileName);

            var subscriber = new EasyUASubscriber();
            subscriber.DataSetMessage += (sender, args) =>
            {
                AssertUtilities.WriteLine();
                AssertUtilities.WriteLine($"DataSetMessage args: {args}");
                if (args.Succeeded)
                    foreach (KeyValuePair<string, UADataSetFieldData> pair in args.DataSetData.FieldDataDictionary)
                        AssertUtilities.WriteLine(pair);
            };

            TestSection.Act();

            UAPubSubConnectionDescriptor pubSubConnectionDescriptor = "opc.udp://224.0.0.22";
            pubSubConnectionDescriptor.UseUdpCaptureFile(captureFileName);

            subscriber.SubscribeDataSet(pubSubConnectionDescriptor);

            Thread.Sleep(5 * 1000);  // TODO:

            TestSection.Assert();

            // TODO: 
        }
    }
}
